> For the complete documentation index, see [llms.txt](https://docs.pyck.cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pyck.cloud/graphql-api/interfaces/withworkflows.md).

# WithWorkflows

Interface for workflow-enabled entities

Audience: Programmer

The `WithWorkflows` interface is implemented by entities that can trigger and participate in Temporal workflows for complex business processes.

## Fields

| Field              | Type                 | Description                          |
| ------------------ | -------------------- | ------------------------------------ |
| `workflows`        | `[Workflow!]`        | Active workflows for this entity     |
| `workflowHistory`  | `WorkflowConnection` | Historical workflow executions       |
| `canStartWorkflow` | `Boolean!`           | Whether new workflows can be started |

## Workflow Integration

Entities with workflows can:

* Trigger automated processes
* Require approvals
* Orchestrate multi-step operations
* Handle long-running tasks
* Implement saga patterns

## Implementing Types

* PickingOrder
* ReceivingInbound
* InventoryItem
* Customer
* Supplier

## Usage

```graphql
query {
  pickingOrder(id: "123") {
    ... on WithWorkflows {
      workflows {
        id
        workflowID
        runID
        status
        startedAt
        completedAt
      }
      canStartWorkflow
    }
  }
}

mutation {
  createWorkflow(input: {
    entityID: "123"
    entityType: "PickingOrder"
    workflowType: "order_fulfillment"
  }) {
    workflow {
      id
      status
    }
  }
}
```

## Common Workflows

* **Order Fulfillment** - Pick, pack, ship
* **Receiving** - Inspect, count, putaway
* **Inventory Counts** - Cycle counting
* **Returns** - RMA processing
* **Transfers** - Multi-step movements

## Workflow States

* `PENDING` - Waiting to start
* `RUNNING` - Currently executing
* `COMPLETED` - Successfully finished
* `FAILED` - Execution failed
* `CANCELLED` - Manually cancelled
* `TERMINATED` - Force stopped

## Best Practices

1. Design idempotent workflow activities
2. Handle partial failures gracefully
3. Implement compensation logic
4. Monitor workflow metrics
5. Set appropriate timeouts

## See Also

* [Workflow Type](/graphql-api/types/workflow.md) - Workflow details
* [WorkflowSignal Type](/graphql-api/types/workflowsignal.md) - Workflow signaling
* [Temporal Metadata](/graphql-api/types/temporalmetadata.md) - Temporal.io integration


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.pyck.cloud/graphql-api/interfaces/withworkflows.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
